#include <cstdio>
#include <cstring>
#include <cstdlib>

int output[32];
int coef[32];
int n;

int evaluate( int x, int m ) {
  int result = 0;
  for ( int i = 1; i <= m; ++i )
    result += (x / i) * coef[i];
  return result;
} 

int main(void) {
  for ( ;; ) {
    scanf("%d", &n);
    if ( n == 0 ) break;
    
    memset( output, 0, sizeof( output ) );
    for ( int i = 0; i < n; ++i ) {
      int a, b;
      scanf("%d%d", &a, &b);
      output[a+1] = b; // shift to [1,11]
    }
    
    output[23] = 1;
    
    for ( int i = 1; i <= 25; ++i )
      coef[i] = output[i] - evaluate( i, i-1 );
    
    int add = -1;
    printf("NUM 1\n");
    printf("ADD\n");
    for ( int i = 1; i <= 25; ++i ) {
      if ( coef[i] == 0 ) continue;
      printf("DUP\n");
      printf("NUM %d\n", i);
      printf("DIV\n");
      if ( coef[i] > 0 ) 
        printf("NUM %d\n", coef[i]);
      else {
        printf("NUM %d\n", -coef[i]);
        printf("INV\n");
      }
      printf("MUL\n");
      printf("SWP\n");
      ++add;
    }
    printf("POP\n");
    for ( int i = 0; i < add; ++i )
      printf("ADD\n");
    printf("END\n\n");
  }
  return 0;
}
